//
//	MiscRuntimeExtensions.h -- an object category to extend the runtime
//		Written by Don Yacktman (c) 1994 by Don Yacktman.
//				Version 1.0.  All rights reserved.
//
//		This notice may not be removed from this source code.
//
//	This object is included in the MiscKit by permission from the author
//	and its use is governed by the MiscKit license, found in the file
//	"LICENSE.rtf" in the MiscKit distribution.  Please refer to that file
//	for a list of all applicable permissions and restrictions.
//	

#import <objc/Object.h>

@interface Object(MiscRuntimeExtensions)

+ (int)instanceSize;
- (int)instanceSize;
- (int)sizeOf;
- becomeClass:aClass;
- _becomeClass:aClass; // no checking!  Be very careful!!!
- (int)compare:anObject;

// Turn on the visual alerts and then unrecognized messages will bring
// up an alert panel instead of just writing something to the console.
// We'll probably add other alerts that get turned on and off by this
// flag in the future, too...
+ setMiscVisualAlerts:(BOOL)aFlag;
+ (BOOL)miscVisualAlerts;
- doesNotRecognize:(SEL)aSelector;


@end
