# links.make
# by Mike Ferris
# Part of MOKit
# Copyright 1993, all rights reserved

# ABOUT MOKit
# by Mike Ferris (mike@lorax.com)
#
# MOKit is a collection of useful and general objects.  Permission is 
# granted by the author to use MOKit in your own programs in any way 
# you see fit.  All other rights pertaining to the kit are reserved by the 
# author including the right to sell these objects as objects,  as part 
# of a LIBRARY, or as SOURCE CODE.  In plain English, I wish to retain 
# rights to these objects as objects, but allow the use of the objects 
# as pieces in a fully functional program.  Permission is also granted to 
# redistribute the source code of MOKit for FREE as long as this copyright 
# notice is left intact and unchanged.  NO WARRANTY is expressed or implied.  
# The author will under no circumstances be held responsible for ANY 
# consequences from the use of these objects.  Since you don't have to pay 
# for them, and full source is provided, I think this is perfectly fair.

# About links.make
#
# This makefile provides a target which will create soft links to
# all the files listed in the make variable SOFTLINKS.
#
# This makefile should be included from the project's Makefile.postamble.
# The Makefile.preamble should add the line "all:: links" to the end
# and should define SOFTLINKS to be a list of files that need to be linked.

LINK_ECHO = echo
LINK_LN_S = /bin/ln -s

links:
	@if [ "$(SOFTLINKS)" ] ; then \
		$(LINK_ECHO) "Making soft links to $(SOFTLINKS)..." ; \
		for i in `/bin/ls -d $(SOFTLINKS)` ; do \
			if [ ! -r `basename $$i` ] ; then \
				$(LINK_LN_S) $$i . ; \
			fi ; \
		done ; \
	fi

