/************************************************************************
  CATEGORY:			MiscFile (Searching)
  CONFORMS TO:		None
  PROGRAMMER:		Todd Thomas	 (todd@avocado.supernet.ab.ca)
  BEGAN:			September 4, 1994	
  LAST CHANGED:		December 11, 1994
  VERSION:			0.1
  CHANGES:			-
  
  Adds the capability of searching an instance of MiscFile for specific 
  filenames. Probably not all that efficient, but it does work. 
		
 *************************************************************************/

#import "MiscFile.h"

@class List;

@interface MiscFile (Searching) 

// Used for searching through MiscFiles and their children to match the 
// given filename. If a match is found, a MiscFile representing the 
// filename is returned, else nil.

- (MiscFile *)searchFor: (const char *)filename;
- (MiscFile *)searchFor: (const char *)filename recursive: (BOOL)recursive; 
- (MiscFile *)searchFor: (const char *)filename recursive: (BOOL)recursive 
	followLinks: (BOOL)followLinks;

// Methods for searching a MiscFile and it's children while consulting the
// class delegate on whether the MiscFile should be added to the List that
// will be returned.

- (List *)searchFiles;
- (List *)searchFilesAndRecurse: (BOOL)recursive;
- (List *)searchFilesAndRecurse: (BOOL)recursive 
	followLinks: (BOOL)followLinks;

@end


@interface Object (MiscFileSearchingDelegate)

- (BOOL)addFile: (MiscFile *) theFile;

@end
