/************************************************************************
  CATEGORY:			MiscFile (Info)
  CONFORMS TO:		None
  PROGRAMMER:		Todd Thomas	 (todd@avocado.supernet.ab.ca)
  BEGAN:			September 5, 1994
  LAST CHANGED:		December 13, 1994
  VERSION:			0.1			
  CHANGES:			-
  
  Adds the ability to get some useful information out of the MiscFile.
  If you are more familiar with standard UNIX calls, check out the
  MiscFile+Unix category.
     
 *************************************************************************/

#import <sys/stat.h>
#import "MiscFile.h"


@interface MiscFile (Info)

// Some more inuitive method names that use stat(2) to get their information.
// (Yes I know there are some fields of the stat struct that are unaccessible
// right now, but they will all be here in the next release. :-)
- (BOOL)isSymbolicLink;
- (BOOL)isDirectory;
- (u_short)permissions;
- (dev_t)device;

// This will be replaced by (MiscUser *)owner in the real release.
- (uid_t)userID;

// This will be replaced by (MiscGroup *)group in the real release.
- (gid_t)groupID;
- (off_t)size;
- (short)hardLinks;

// These will return (MiscTime *) objects in a future release.
- (time_t)lastAccessTime;
- (time_t)lastModifyTime;
- (time_t)lastStatusChange;

// Some methods to extract info about the MiscFile (uses access(2))
- (BOOL)readAccess;
- (BOOL)writeAccess;
- (BOOL)executeAccess;
- (BOOL)doesExist;

@end
