/************************************************************************
  CATEGORY:			MiscFile (Modification)
  CONFORMS TO:		None
  PROGRAMMER:		Todd Thomas	 (todd@avocado.supernet.ab.ca)
  BEGAN:			December 10, 1994
  LAST CHANGED:		December 13, 1994
  VERSION:			0.1		
  CHANGES:			-	

  Adds the ability to change the file characteristic of the MiscFile.
  This includes filename changes, permission changes, etc.  This category 
  uses lower level calls declared in the UnixModification category.
       
 *************************************************************************/

#import "MiscFile.h"


@interface MiscFile (Modification)
// Resets owner/group/other to what you give in perms.
- (int)setPermissions: (int)perms for: (int)who;

// Adds permissions given while leaving the rest alone.
- (int)addPermissions: (int)perms for: (int)who;

// Removes permissions given while leaving the rest alone.
- (int)removePermissions: (int)perms for: (int)who;

// There should also be some change owner and change group methods
// included here... they will be added, hopefully using the 
// MiscUser and MiscGroup classes.

@end
