{\rtf0\ansi{\fonttbl\f0\fmodern Courier;}
\paperw11760
\paperh7800
\margl120
\margr120
\pard\tx560\tx1140\tx1680\tx2260\tx2800\tx3440\tx3920\tx4600\tx10360\tx11520\f0\b0\i0\ulnone\fs24\fc0\cf0 /************************************************************************\
  CATEGORY:			MiscFile (Searching)\
\
  See the header for more information on this category.\
 *************************************************************************/\
\
#import <appkit/appkit.h>\
#import "MiscFile+Searching.h"\
#import "MiscFile+Info.h"\
\
\

\b @interface MiscFile (PrivateSearching)
\b0 \
\
- (BOOL)_addFile: (MiscFile *)aFile;\
\

\b @end
\b0 \
\
\

\b @implementation MiscFile (Searching)
\b0 \
\

\b - (MiscFile *)searchFor: (const char *)filename 
\b0 \
\{\
	return [self searchFor: filename recursive: NO followLinks: NO];\
\}\
\
\
\

\b - (MiscFile *)searchFor: (const char *)filename recursive: (BOOL)recursive\

\b0 \{\
	return [self searchFor: filename recursive: recursive followLinks: NO];	
\b \

\b0 \}\
\
\
\
// The method that does the actual searching. First it checks itself, then\
// if recursion is YES, passes the message onto it's children until it is\
// either done, or one of them matches. If rercursion is NO this method\
// simply checks it's children itself and returns the child if any of them\
// match.\
\

\b - (MiscFile *)searchFor: (const char *)filename recursive: (BOOL)recursive \
				followLinks: (BOOL)followLinks
\b0 \
\{\
  id  found = nil;\
  int  i = 0;\
  \
	if (filename == NULL || visited == YES)\
		return nil;\
\
	if ([self isSymbolicLink] && followLinks == NO)\
		return nil;\
		\
	if (strcmp ([self filename], filename) == 0)\
	\{\
		visited = NO;\
		return self;\
	 \}\
	 \
	// if we don't match, then check our children\
	visited = YES;\
	for (i=0; i<[ [self children] count]; i++)\
	\{\
		if (recursive)\
		\{	\
			// just pass the message along to all our children\
			found = [ [ [self children] objectAt: i] searchFor: filename\
							recursive: YES followLinks: followLinks];\
			if (found != nil)\
			\{\
				visited = NO;\
				return found;\
			 \}		\
		 \}	\
		else\
		\{\
			// just compare our children's filenames to what we are searching\
			if (strcmp ([ [ [self children] objectAt: i] filename], \
							filename) == 0)\
			\{\
				visited = NO;\
				return [ [self children] objectAt: i];\
			 \}\
		 \}\
	 \}\
\
	// if we've gotten this far, neither us nor our children match filename\
	visited = NO;\
	return nil;\
\}\
\
\
\

\b - (List *)searchFiles
\b0 \
\{\
	return [self searchFilesAndRecurse: NO followLinks: NO];\
\}\
\
\
\

\b - (List *)searchFilesAndRecurse: (BOOL)recursive
\b0 \
\{\
	return [self searchFilesAndRecurse: recursive followLinks: NO];\
\}\
\
\
\

\b - (List *)searchFilesAndRecurse: (BOOL)recursive \
				followLinks: (BOOL)followLinks
\b0 \
\{\
  id  matchList = nil;\
  id  theirList;\
  int  i = 0;\
  \
	if (visited == YES)\
		return nil;\
\
	if ([self isSymbolicLink] && followLinks == NO)\
		return nil;\
		\
	if ([self _addFile: self] == YES)\
	\{\
		matchList = [ [List alloc] init];\
		[matchList addObject: self];\
	 \}\
	 \
	// Ask our children.\
	visited = YES;\
	for (i=0; i<[ [self children] count]; i++)\
	\{\
		if (recursive)\
		\{	\
			// just pass the message along to all our children\
			theirList = [ [ [self children] objectAt: i] \
							searchFilesAndRecurse:YES followLinks: followLinks];\
			if (theirList != nil)\
			\{\
				if (matchList == nil)\
					matchList = [ [List alloc] init];\
				[matchList appendList: theirList];\
				theirList = [theirList free];\
			 \}		\
		 \}	\
		else\
		\{\
			// just compare our children's filenames to what we are searching\
			if ([self _addFile: [ [self children] objectAt: i] ] == YES)\
			\{\
				if (matchList == nil)\
					matchList = [ [List alloc] init];\
				[matchList addObject: [ [self children] objectAt: i] ];\
			 \}\
		 \}\
	 \}\
\
	visited = NO;\
	return matchList;\
\}\
	\

\b @end
\b0 \
\

\pard\tx1140\tx2300\tx3440\tx4600\tx5760\tx6900\tx8060\tx9200\tx10360\tx11520\fc0\cf0 \

\pard\tx560\tx1140\tx1680\tx2260\tx2800\tx3440\tx3920\tx4600\tx10360\tx11520\b\fc0\cf0 @implementation MiscFile (PrivateSearching)
\b0 \
\

\b - (BOOL)_addFile: (MiscFile *)aFile\

\b0 \{\
	// Consults the class delegate (if there is one) and asks if\
	// aFile should be added to the list of MiscFiles being searched.\
	id  classDelegate = [ [self class] classDelegate];\
	\
	if (classDelegate != nil && \
					[classDelegate respondsTo: @selector(addFile:)])\
		return [classDelegate addFile: aFile];\
\
	return NO;\
\}\
\

\b @end
\b0 \

}
