/************************************************************************
  CATEGORY:			MiscFile (Unix)
  CONFORMS TO:		None
  PROGRAMMER:		Todd Thomas	 (todd@avocado.supernet.ab.ca)
  BEGAN:			December 10, 1994
  LAST CHANGED:		December 11, 1994
  VERSION:			0.1			
  CHANGES:			-
  
  Provides wrappers for the lower level file Unix stuff. Therefore, if the 
  underlying OS calls change with OpenStep then we should only have to change 
  this category.
     
 *************************************************************************/

#import <sys/types.h>
#import "MiscFile.h"


@interface MiscFile (Unix)

// Methods for getting information about the receiving MiscFile.
- (int)access: (int)mode;
- (int)lstat: (struct stat *)stats;
- (int)stat: (struct stat *)stats;

// Methods for changing the receiving MiscFile's characteristics.
- (int)chmod: (unsigned short)mode;
- (int)chown: (uid_t)owner group: (gid_t)group;

// Methods for creating new files.
- (int)link: (const char *)newpath;
- (int)symlink: (const char *)newpath;

@end
